<template>
    <div class="action-container">
      <div class="like-container" @mouseenter="startHoverTimer" @mouseleave="cancelHoverTimer">
        <span class="comment-action like-btn" :class="{ active: hovered || selected, selected:selectedEmoji === emojis[0],'red': selectedEmoji === emojis[1],'yellow': selectedEmoji === emojis[2], 'yellow-asombra': selectedEmoji === emojis[3], 'yellow-entristece': selectedEmoji === emojis[4], 'orange-enfada': selectedEmoji === emojis[5] }" @click="toggleLike"
          @mouseenter="cancelCloseTimer" @mouseleave="startCloseTimer" style="margin-left: -7px;">
          <i :class="[{ 'blue': selected }]"></i>
          <span :style="{ color: selectedEmoji === emojis[5] ? '#FFA500' : (selected ? 'blue' : '') }"
          :class="{ 'like-text-blue': selectedEmoji === emojis[0] }">{{ selectedEmoji ? selectedEmoji.name : 'Me gusta'
          }}</span>
        </span>
        <div v-show="showEmojis" class="like-icon" @mouseenter="cancelCloseTimer" @mouseleave="startCloseTimer" style="margin-left: -75px; margin-top: 10px ;">
          <span v-for="emoji in emojis" :key="emoji.name" @click="selectEmoji(emoji)"
            @mouseenter="showEmojiName = emoji.name" @mouseleave="showEmojiName = null" class="emoji"
            :class="{ active: selectedEmoji === emoji }">
            {{ emoji.symbol }}
          </span>
        </div>
        <span v-if="showEmojiName" class="emoji-name">{{ showEmojiName }}</span>
      </div>
    </div>
  </template>
  
  <script>
  import axios from "axios";
  export default {
    props: {
  publicacionId: {
    type: Number,
    required: true
  },
  comentarioId: {
    type: Number,
    required: true
  }
},
    data() {
      return {
        reactionId: null,
        hovered: false,
        selected: false,
        selectedEmoji: null,
        showEmojis: false,
        hoverTimeout: null,
        closeTimeout: null,
        showEmojiName: null,
        isHovered: false,
        hasReacted: false,
        emojis: [
          { name: "Me gusta", symbol: "👍" },
          { name: "Me encanta", symbol: "😍" },
          { name: "Me divierte", symbol: "😂" },
          { name: "Me asombra", symbol: "😮" },
          { name: "Me entristece", symbol: "😢" },
          { name: "Me enfada", symbol: "😡" },
        ],
        token: "eyJhbGciOiJIUzI1NiJ9.eyJzdWIiOiJnaW92YW5uaWNhc3NhbmVsbGk2NEBnbWFpbC5jb20iLCJleHAiOjE2ODc3NjI5NzEsIm5vbWJyZSI6Ikdva3UifQ.uvtzVoLuD9RaxKxFn8NYsEUWMeNqae5KLwpvUY2o53s"

      };
    },
    created() {
  // Or use mounted() if appropriate for your use case
  this.fetchReaction();
},
    methods: {
        fetchReaction() {
      axios
        .get(`http://localhost:3001/comentarios/${this.comentarioId}/reacciones`)
        .then((response) => {
          const reacciones = response.data;
          // Update the data with the fetched reactions
          if (reacciones.length > 0) {
            // Assuming the first reaction is the user's reaction
            const userReaction = reacciones[0];
            const selectedEmoji = this.emojis.find(
              (emoji) => emoji.name === userReaction.tipo
            );
            this.selectedEmoji = selectedEmoji;
            this.hasReacted = true;
            this.reactionId = userReaction.id;
          }
        })
        .catch((error) => {
          console.error('Error fetching reactions:', error);
        });
    },
  
  toggleLike() {
  if (this.hasReacted) {
    this.eliminarReaccion(); // Llamar a la API para eliminar la reacción existente
    return;
  }

  // Eliminar la clase "like-text-blue" antes de cambiar el estado
  if (this.selected && this.selectedEmoji === this.emojis[0]) {
    const likeBtn = document.querySelector('.like-btn');
    likeBtn.classList.remove('like-text-blue');
  }

  this.selectedEmoji = this.selected ? this.emojis[0] : null;
  this.cancelHoverTimer();
  this.hasReacted = true;
},

editarReaccion() {
  if (!this.hasReacted || !this.reactionId || !this.selectedEmoji) {
    return; // No se ha reaccionado previamente o no hay una reacción válida seleccionada
  }

  axios
    .put(
      `http://localhost:3001/reacciones/editar/${this.reactionId}`,
      null,
      {
        params: {
          nuevoTipo: this.selectedEmoji.name,
        }
      }
    )
    .then((response) => {
      console.log('Reacción editada:', response.data);
    })
    .catch((error) => {
      console.error('Error al editar la reacción:', error);
    });
},

selectEmoji(emoji) {
  this.selectedEmoji = emoji;
  this.cancelHoverTimer();
  this.showEmojis = false;

  if (this.hasReacted) {
    this.editarReaccion(); // Llamar a la API para editar la reacción existente
  } else {
    axios
      .post(
        'http://localhost:3001/reacciones/reaccion-comentario',
        null,
        {
          params: {
            publicacionId: this.publicacionId,
            comentarioId: this.comentarioId,
            tipo: emoji.name,
          }
        }
      )
      .then((response) => {
        console.log('Reacción guardada:', response.data);
        this.reactionId = response.data.id; // Asignar la ID de la reacción creada
        this.hasReacted = true;
        console.log('reactionId:', this.reactionId);
      })
      .catch((error) => {
        console.error('Error al guardar la reacción:', error);
      });
  }
},

eliminarReaccion() {
  if (!this.hasReacted || !this.reactionId) {
    return; // No se ha reaccionado previamente o no hay una reacción válida para eliminar
  }

  axios
    .delete(`http://localhost:3001/reacciones/eliminar/${this.reactionId}`)
    .then((response) => {
      console.log('Reaction deleted:', response.data);
      this.selectedEmoji = null; // Reiniciar la selección del emoji
      this.hasReacted = false; // Actualizar el estado de reacción
      this.reactionId = null; // Reiniciar la ID de la reacción
    })
    .catch((error) => {
      console.error('Error deleting reaction:', error);
    });
},

      startHoverTimer() {
        this.hoverTimeout = setTimeout(() => {
          this.hovered = true;
          this.showEmojis = true;
        }, 1000);
      },
      cancelHoverTimer() {
        clearTimeout(this.hoverTimeout);
        this.hovered = false;
      },
      startCloseTimer() {
        this.closeTimeout = setTimeout(() => {
          this.showEmojis = false;
        }, 500);
      },
      cancelCloseTimer() {
        clearTimeout(this.closeTimeout);
      },
    },
  };
  </script>
  
  <style scoped>
  .comment-action {
  margin-right: 10px;
  cursor: pointer;
  font-size: 11px;
  color: #999999;
  transition: color 0.3s;
}
  
  .like-container {
    position: relative;
    display: flex;
    justify-content: flex-end;
    align-items: center;
  }
  
  .like-btn {
  margin-right: 5px;
  margin-left: 65px;
  border: none;
  background-color: transparent;
  cursor: pointer;
  padding: 5px;
  border-radius: 20px;
  transition: background-color 0.3s, border-color 0.3s;
}
  
.like-btn:hover {
  background-color: #f0f0f0;
  border-color: #ccc;
}
  
  .like-icon {
    position: absolute;
    top: -40px;
    left: 65px;
    width: fit-content;
    height: 125%;
    object-fit: contain;
    opacity: 0;
    transition: opacity 0.3s ease;
    background-color: #f2f2f2;
    border-radius: 20px;
    overflow: hidden;
  }
  
  .like-icon {
    display: flex;
    align-items: center;
  }
  
  .emoji {
    font-size: 20px;
    padding: 5px 10px;
    cursor: pointer;
    position: relative;
  }
  
  .emoji.active {
    background-color: #ccc;
  }
  
  .emoji-name {
    position: absolute;
    top: -60px;
    left: 125%;
    transform: translateX(-50%);
    background-color: #000;
    color: #fff;
    padding: 2px 4px;
    font-size: 12px;
    border-radius: 4px;
    opacity: 0.7;
    white-space: nowrap;
  }
  
  .action-container {
    display: inline-flex;
    align-items: center;
    margin-right: 5px;
    cursor: pointer;
  }
  
  .like-btn.active + .like-icon {
    opacity: 1;
  }
  .hovered {
  text-decoration: underline;
}

.selected {
  color: #1877F2;
}
.like-text-blue {
  color: #1877F2;
}
.blue {
  color: #1877F2;
}
.red {
  color: #FA383E;
}
.yellow {
  color: #F5C33B;
}

.yellow-asombra {
  color: #F5C33B;
}

.yellow-entristece {
  color: #F5C33B;
}

.orange-enfada {
  color: #FFA500;
}

  </style>
  